﻿@{
    ViewData["Title"] = "Home Page";
}
<div id="chat">
    <h3 id="spn-nick"></h3>
    <form id="frm-send-message" action="#">
        <label for="message">Message:</label>
        <input type="text" id="message" />
        <input type="submit" id="send" value="Send" class="send" />
    </form>
    <div class="clear">
    </div>
    <ul id="messages"></ul>
</div>

<div id="audit">
    <form id="frm-audit-message" action="#">
        <label for="id">Id:</label>
        <input type="text" id="id" />
        <label for="audit-message">Message:</label>
        <input type="text" id="audit-message" />
        <input type="submit" id="submit-audit" value="Audit" />
    </form>
</div>

<script src="lib/signalr/signalr.min.js"></script>
<script src="https://code.jquery.com/jquery-3.4.1.min.js"
        integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
        crossorigin="anonymous">
</script>

<script>
    var connection = new signalR.HubConnectionBuilder()
        .withUrl("/chat")
        .build();
    connection.start().catch(err => console.error(err.toString()));

    connection.on('DisplayMessage', (id, nick, message) => {
        appendNewMessage(id, nick, message);
    });

    connection.on('DisplayNewUser', (username) => {
        appendNewUser(username);
    });

    $(document).ready(function () {
        document.getElementById('frm-send-message').addEventListener('submit', event => {
            var message = $('#message').val();
            $('#message').val('');

            connection.invoke('SendMessage', message);
            event.preventDefault();
        });

        document.getElementById('frm-audit-message').addEventListener('submit', event => {
            event.preventDefault();
            var data = new Object();
            data.id = $("#id").val();
            data.message = $("#audit-message").val();

            $.post("https://localhost:44317/Home/AuditMessage", data)
                .done(function (result) {
                
                    alert(result == true ? "Exact message exist" : "Message exist but it is different");
                })
                .fail(function () {
                    alert("no message with this id");
                });
        });
    });

    function appendNewMessage(id, nick, message) {
        var idElement = document.createElement('strong');
        idElement.innerText = `${id}, `;
        var nameElement = document.createElement('strong');
        nameElement.innerText = `${nick}:`;
        var msgElement = document.createElement('em');
        msgElement.innerText = ` ${message}`;
        var li = document.createElement('li');
        li.appendChild(idElement);
        li.appendChild(nameElement);
        li.appendChild(msgElement);

        $('#messages').append(li);
    };

    function appendNewUser(nick) {
        var nameElement = document.createElement('strong');
        nameElement.innerText = `${nick} joined the chat!`;
        var li = document.createElement('li');
        li.appendChild(nameElement);

        $('#messages').append(li);
    };
</script>